------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2011 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
limited with Qt4.Mime_Datas;
with Qt4.Model_Index_Lists;
with Qt4.Model_Indices;
with Qt4.Objects;
with Qt4.Sizes;
with Qt4.String_Lists;
with Qt4.Variants;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Abstract_Item_Models is

   type Q_Abstract_Item_Model is limited interface
     and Qt4.Objects.Q_Object;

   type Q_Abstract_Item_Model_Access is
     access all Q_Abstract_Item_Model'Class;
   for Q_Abstract_Item_Model_Access'Storage_Size use 0;

   type Q_Abstract_Item_Model_Pointer is tagged;

   not overriding
   function Buddy
    (Self : not null access constant Q_Abstract_Item_Model;
     Index : Qt4.Model_Indices.Q_Model_Index)
       return Qt4.Model_Indices.Q_Model_Index
         is abstract;

   not overriding
   function Can_Fetch_More
    (Self : not null access constant Q_Abstract_Item_Model;
     Parent : Qt4.Model_Indices.Q_Model_Index)
       return Standard.Boolean
         is abstract;

   not overriding
   function Column_Count
    (Self : not null access constant Q_Abstract_Item_Model;
     Parent : Qt4.Model_Indices.Q_Model_Index
       := Qt4.Model_Indices.Create)
       return Qt4.Q_Integer
         is abstract;

   not overriding
   function Drop_Mime_Data
    (Self : not null access Q_Abstract_Item_Model;
     Data : access Qt4.Mime_Datas.Q_Mime_Data'Class;
     Action : Qt4.Drop_Action;
     Row : Qt4.Q_Integer;
     Column : Qt4.Q_Integer;
     Parent : Qt4.Model_Indices.Q_Model_Index)
       return Standard.Boolean
         is abstract;

   not overriding
   procedure Fetch_More
    (Self : not null access Q_Abstract_Item_Model;
     Parent : Qt4.Model_Indices.Q_Model_Index)
       is abstract;

   not overriding
   function Has_Children
    (Self : not null access constant Q_Abstract_Item_Model;
     Parent : Qt4.Model_Indices.Q_Model_Index
       := Qt4.Model_Indices.Create)
       return Standard.Boolean
         is abstract;

   not overriding
   function Has_Index
    (Self : not null access constant Q_Abstract_Item_Model;
     Row : Qt4.Q_Integer;
     Column : Qt4.Q_Integer;
     Parent : Qt4.Model_Indices.Q_Model_Index
       := Qt4.Model_Indices.Create)
       return Standard.Boolean
         is abstract;

   not overriding
   function Index
    (Self : not null access constant Q_Abstract_Item_Model;
     Row : Qt4.Q_Integer;
     Column : Qt4.Q_Integer;
     Parent : Qt4.Model_Indices.Q_Model_Index
       := Qt4.Model_Indices.Create)
       return Qt4.Model_Indices.Q_Model_Index
         is abstract;

   function Insert_Column
    (Self : not null access Q_Abstract_Item_Model'Class;
     Column : Qt4.Q_Integer;
     Parent : Qt4.Model_Indices.Q_Model_Index
       := Qt4.Model_Indices.Create)
       return Standard.Boolean;

   not overriding
   function Insert_Columns
    (Self : not null access Q_Abstract_Item_Model;
     Column : Qt4.Q_Integer;
     Count : Qt4.Q_Integer;
     Parent : Qt4.Model_Indices.Q_Model_Index
       := Qt4.Model_Indices.Create)
       return Standard.Boolean
         is abstract;

   function Insert_Row
    (Self : not null access Q_Abstract_Item_Model'Class;
     Row : Qt4.Q_Integer;
     Parent : Qt4.Model_Indices.Q_Model_Index
       := Qt4.Model_Indices.Create)
       return Standard.Boolean;

   not overriding
   function Insert_Rows
    (Self : not null access Q_Abstract_Item_Model;
     Row : Qt4.Q_Integer;
     Count : Qt4.Q_Integer;
     Parent : Qt4.Model_Indices.Q_Model_Index
       := Qt4.Model_Indices.Create)
       return Standard.Boolean
         is abstract;

   not overriding
   function Mime_Data
    (Self : not null access constant Q_Abstract_Item_Model;
     Indexes : Qt4.Model_Index_Lists.Q_Model_Index_List)
       return access Qt4.Mime_Datas.Q_Mime_Data'Class
         is abstract;

   not overriding
   function Mime_Types
    (Self : not null access constant Q_Abstract_Item_Model)
       return Qt4.String_Lists.Q_String_List
         is abstract;

   not overriding
   function Parent
    (Self : not null access constant Q_Abstract_Item_Model;
     Child : Qt4.Model_Indices.Q_Model_Index)
       return Qt4.Model_Indices.Q_Model_Index
         is abstract;

   function Remove_Column
    (Self : not null access Q_Abstract_Item_Model'Class;
     Column : Qt4.Q_Integer;
     Parent : Qt4.Model_Indices.Q_Model_Index
       := Qt4.Model_Indices.Create)
       return Standard.Boolean;

   not overriding
   function Remove_Columns
    (Self : not null access Q_Abstract_Item_Model;
     Column : Qt4.Q_Integer;
     Count : Qt4.Q_Integer;
     Parent : Qt4.Model_Indices.Q_Model_Index
       := Qt4.Model_Indices.Create)
       return Standard.Boolean
         is abstract;

   function Remove_Row
    (Self : not null access Q_Abstract_Item_Model'Class;
     Row : Qt4.Q_Integer;
     Parent : Qt4.Model_Indices.Q_Model_Index
       := Qt4.Model_Indices.Create)
       return Standard.Boolean;

   not overriding
   function Remove_Rows
    (Self : not null access Q_Abstract_Item_Model;
     Row : Qt4.Q_Integer;
     Count : Qt4.Q_Integer;
     Parent : Qt4.Model_Indices.Q_Model_Index
       := Qt4.Model_Indices.Create)
       return Standard.Boolean
         is abstract;

   not overriding
   function Row_Count
    (Self : not null access constant Q_Abstract_Item_Model;
     Parent : Qt4.Model_Indices.Q_Model_Index
       := Qt4.Model_Indices.Create)
       return Qt4.Q_Integer
         is abstract;

   function Sibling
    (Self : not null access constant Q_Abstract_Item_Model'Class;
     Row : Qt4.Q_Integer;
     Column : Qt4.Q_Integer;
     Idx : Qt4.Model_Indices.Q_Model_Index)
       return Qt4.Model_Indices.Q_Model_Index;

   not overriding
   function Span
    (Self : not null access constant Q_Abstract_Item_Model;
     Index : Qt4.Model_Indices.Q_Model_Index)
       return Qt4.Sizes.Q_Size
         is abstract;

   not overriding
   procedure Revert
    (Self : not null access Q_Abstract_Item_Model)
       is abstract;

   not overriding
   function Submit
    (Self : not null access Q_Abstract_Item_Model)
       return Standard.Boolean
         is abstract;

   not overriding
   function Data
    (Self  : not null access Q_Abstract_Item_Model;
     Index : Qt4.Model_Indices.Q_Model_Index;
     Role  : Item_Data_Role := Display_Role)
       return Qt4.Variants.Q_Variant
         is abstract;

   not overriding
   function Flags
    (Self  : not null access constant Q_Abstract_Item_Model;
     Index : Qt4.Model_Indices.Q_Model_Index)
       return Qt4.Item_Flags
         is abstract;

   not overriding
   function Header_Data
    (Self        : not null access Q_Abstract_Item_Model;
     Section     : Qt4.Q_Integer;
     Orientation : Qt4.Orientations;
     Role        : Item_Data_Role := Display_Role)
       return Qt4.Variants.Q_Variant
         is abstract;

   not overriding
   function Set_Data
    (Self  : not null access Q_Abstract_Item_Model;
     Index : Qt4.Model_Indices.Q_Model_Index;
     Value : Qt4.Variants.Q_Variant;
     Role  : Qt4.Item_Data_Role := Edit_Role)
       return Boolean
         is abstract;

   not overriding
   function Set_Header_Data
    (Self    : not null access Q_Abstract_Item_Model;
     Section : Qt4.Q_Integer;
     Orient  : Qt4.Orientation;
     Value   : Qt4.Variants.Q_Variant;
     Role    : Item_Data_Role := Edit_Role) return Boolean
       is abstract;

   procedure Remove_Rows
    (Self   : not null access Q_Abstract_Item_Model'Class;
     Row    : Qt4.Q_Integer;
     Count  : Qt4.Q_Integer;
     Parent : Qt4.Model_Indices.Q_Model_Index := Qt4.Model_Indices.Create);
   --  Convenience wrapper fot removeRows. Raise Program_Error if operation
   --  fail.

   procedure Insert_Rows
    (Self   : not null access Q_Abstract_Item_Model'Class;
     Row    : Qt4.Q_Integer;
     Count  : Qt4.Q_Integer;
     Parent : Qt4.Model_Indices.Q_Model_Index := Qt4.Model_Indices.Create);
   --  Convenience wrapper fot insertRows. Raise Program_Error if operation
   --  fail.

   procedure Set_Data
    (Self  : not null access Q_Abstract_Item_Model'Class;
     Index : Qt4.Model_Indices.Q_Model_Index;
     Value : Qt4.Variants.Q_Variant;
     Role  : Qt4.Item_Data_Role := Qt4.Edit_Role);
   --  Convenience wrapper fot setData. Raise Program_Error if operation fail.

   procedure Set_Header_Data
    (Self    : not null access Q_Abstract_Item_Model'Class;
     Section : Qt4.Q_Integer;
     Orient  : Qt4.Orientation;
     Value   : Qt4.Variants.Q_Variant;
     Role    : Qt4.Item_Data_Role := Qt4.Edit_Role);
   --  Convenience wrapper fot setHeaderData. Raise Program_Error if operation
   --  fail.

   package Q_Abstract_Item_Model_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Abstract_Item_Model, Q_Abstract_Item_Model_Access);

   type Q_Abstract_Item_Model_Pointer is
     new Q_Abstract_Item_Model_Pointers.Q_Pointer with null record;

end Qt4.Abstract_Item_Models;
